#include <string>

#ifndef L7_UTIL_H

#define L7_UTIL_H

#define L7VERSION 0.4

/* never worry about timersub type activies again -- from GLIBC and upcased. */
#define TIMERSUB(a, b, result)                                                \
  do {                                                                        \
    (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;                             \
    if ((a)->tv_usec < (b)->tv_usec) {                                        \
      (result)->tv_usec = (b)->tv_usec - (a)->tv_usec;                        \
      (result)->tv_sec -= 1;		                                      \
    }                                                                         \
    else (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;		      \
  } while (0)

void l7printf(int triviality, const char * format, ...);

string friendly_print(unsigned char *s, int size);
void print_give_up(string key, unsigned char *buf, int len);
string get_conntrack_key(const string & protocol, const string & sip, const string & dip, unsigned short sport, unsigned short dport);

#endif
